Index: /LMDZ5/trunk/libf/phylmd/aeropt_5wv.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/aeropt_5wv.F90	(revision 2145)
+++ /LMDZ5/trunk/libf/phylmd/aeropt_5wv.F90	(revision 2146)
@@ -57,5 +57,5 @@
   REAL, DIMENSION(klon,klev), INTENT(in)   :: pdel
   REAL, INTENT(in)                         :: delt
-  REAL, DIMENSION(klon,klev,naero_spc), INTENT(in) :: m_allaer
+  REAL, DIMENSION(klon,klev,naero_tot), INTENT(in) :: m_allaer
   REAL, DIMENSION(klon,klev), INTENT(in)   :: RHcl     ! humidite relative ciel clair
   INTEGER,INTENT(in)                       :: flag_aerosol
@@ -67,6 +67,8 @@
   !
   REAL, DIMENSION(klon), INTENT(out)          :: ai      ! POLDER aerosol index 
-  REAL, DIMENSION(klon,nwave,naero_spc), INTENT(out)      :: tausum
-  REAL, DIMENSION(klon,klev,nwave,naero_spc), INTENT(out) :: tau
+!  REAL, DIMENSION(klon,nwave,naero_spc), INTENT(out)      :: tausum
+!  REAL, DIMENSION(klon,klev,nwave,naero_spc), INTENT(out) :: tau
+  REAL, DIMENSION(klon,nwave,naero_tot), INTENT(out)      :: tausum
+  REAL, DIMENSION(klon,klev,nwave,naero_tot), INTENT(out) :: tau
 
 
@@ -77,5 +79,5 @@
   LOGICAL :: soluble
   
-  INTEGER :: i, k, ierr, m
+  INTEGER :: i, k, ierr, m, aerindex
   INTEGER :: spsol, spinsol, spss, la
   INTEGER :: RH_num(klon,klev)
@@ -156,5 +158,5 @@
   REAL :: piz_aeri_5wv(las,naero_insoluble)           ! Insoluble comp. 1- Dust: 2- BC; 3- POM
 
-  REAL, DIMENSION(klon,klev,naero_spc) :: mass_temp
+  REAL, DIMENSION(klon,klev,naero_tot) :: mass_temp
   
   !
@@ -639,39 +641,39 @@
      nb_aer = 2
      ALLOCATE (aerosol_name(nb_aer)) 
-     aerosol_name(1) = id_ASSO4M
-     aerosol_name(2) = id_CSSO4M
+     aerosol_name(1) = id_ASSO4M_phy
+     aerosol_name(2) = id_CSSO4M_phy
   ELSEIF (flag_aerosol .EQ. 2) THEN
      nb_aer = 2
      ALLOCATE (aerosol_name(nb_aer)) 
-     aerosol_name(1) = id_ASBCM
-     aerosol_name(2) = id_AIBCM
+     aerosol_name(1) = id_ASBCM_phy
+     aerosol_name(2) = id_AIBCM_phy
   ELSEIF (flag_aerosol .EQ. 3) THEN 
      nb_aer = 2
      ALLOCATE (aerosol_name(nb_aer)) 
-     aerosol_name(1) = id_ASPOMM
-     aerosol_name(2) = id_AIPOMM
+     aerosol_name(1) = id_ASPOMM_phy
+     aerosol_name(2) = id_AIPOMM_phy
   ELSEIF (flag_aerosol .EQ. 4) THEN 
      nb_aer = 3
      ALLOCATE (aerosol_name(nb_aer)) 
-     aerosol_name(1) = id_CSSSM
-     aerosol_name(2) = id_SSSSM
-     aerosol_name(3) = id_ASSSM
+     aerosol_name(1) = id_CSSSM_phy
+     aerosol_name(2) = id_SSSSM_phy
+     aerosol_name(3) = id_ASSSM_phy
   ELSEIF (flag_aerosol .EQ. 5) THEN 
      nb_aer = 1
      ALLOCATE (aerosol_name(nb_aer)) 
-     aerosol_name(1) = id_CIDUSTM
+     aerosol_name(1) = id_CIDUSTM_phy
   ELSEIF (flag_aerosol .EQ. 6) THEN 
      nb_aer = 10
      ALLOCATE (aerosol_name(nb_aer)) 
-     aerosol_name(1) = id_ASSO4M      
-     aerosol_name(2) = id_ASBCM
-     aerosol_name(3) = id_AIBCM
-     aerosol_name(4) = id_ASPOMM
-     aerosol_name(5) = id_AIPOMM
-     aerosol_name(6) = id_CSSSM
-     aerosol_name(7) = id_SSSSM
-     aerosol_name(8) = id_ASSSM
-     aerosol_name(9) = id_CIDUSTM
-     aerosol_name(10) = id_CSSO4M
+     aerosol_name(1) = id_ASSO4M_phy
+     aerosol_name(2) = id_ASBCM_phy
+     aerosol_name(3) = id_AIBCM_phy
+     aerosol_name(4) = id_ASPOMM_phy
+     aerosol_name(5) = id_AIPOMM_phy
+     aerosol_name(6) = id_CSSSM_phy
+     aerosol_name(7) = id_SSSSM_phy
+     aerosol_name(8) = id_ASSSM_phy
+     aerosol_name(9) = id_CIDUSTM_phy
+     aerosol_name(10) = id_CSSO4M_phy
   ENDIF
 
@@ -712,43 +714,43 @@
   DO m=1,nb_aer   ! tau is only computed for each mass    
     fac=1.0
-    IF (aerosol_name(m).EQ.id_ASBCM) THEN
+    IF (aerosol_name(m).EQ.id_ASBCM_phy) THEN
         soluble=.TRUE.
         spsol=1
         spss=0
-    ELSEIF (aerosol_name(m).EQ.id_ASPOMM) THEN 
+    ELSEIF (aerosol_name(m).EQ.id_ASPOMM_phy) THEN 
         soluble=.TRUE.
         spsol=2 
         spss=0
-    ELSEIF (aerosol_name(m).EQ.id_ASSO4M) THEN
+    ELSEIF (aerosol_name(m).EQ.id_ASSO4M_phy) THEN
         soluble=.TRUE.
         spsol=3
         spss=0
         fac=1.375    ! (NH4)2-SO4/SO4 132/96 mass conversion factor for OD
-    ELSEIF (aerosol_name(m).EQ.id_CSSO4M) THEN
+    ELSEIF (aerosol_name(m).EQ.id_CSSO4M_phy) THEN
         soluble=.TRUE.
         spsol=4
         spss=0
         fac=1.375    ! (NH4)2-SO4/SO4 132/96 mass conversion factor for OD
-    ELSEIF (aerosol_name(m).EQ.id_SSSSM) THEN 
+    ELSEIF (aerosol_name(m).EQ.id_SSSSM_phy) THEN 
         soluble=.TRUE.
         spsol=5
         spss=3
-    ELSEIF (aerosol_name(m).EQ.id_CSSSM) THEN 
+    ELSEIF (aerosol_name(m).EQ.id_CSSSM_phy) THEN 
         soluble=.TRUE.
         spsol=6
         spss=2
-    ELSEIF (aerosol_name(m).EQ.id_ASSSM) THEN
+    ELSEIF (aerosol_name(m).EQ.id_ASSSM_phy) THEN
         soluble=.TRUE.
         spsol=7
         spss=1
-    ELSEIF (aerosol_name(m).EQ.id_CIDUSTM) THEN 
+    ELSEIF (aerosol_name(m).EQ.id_CIDUSTM_phy) THEN 
         soluble=.FALSE.
         spinsol=1
         spss=0
-    ELSEIF  (aerosol_name(m).EQ.id_AIBCM) THEN 
+    ELSEIF  (aerosol_name(m).EQ.id_AIBCM_phy) THEN 
         soluble=.FALSE.
         spinsol=2
         spss=0
-    ELSEIF (aerosol_name(m).EQ.id_AIPOMM) THEN 
+    ELSEIF (aerosol_name(m).EQ.id_AIPOMM_phy) THEN 
         soluble=.FALSE.
         spinsol=3
@@ -765,4 +767,6 @@
       used_tau(naero_soluble+spinsol)=.TRUE.
     ENDIF
+
+    aerindex=aerosol_name(m)
 
     DO la=1,las
@@ -779,7 +783,7 @@
                 H=rh(i,k)/100
                 tau_ae5wv_int=A1_ASSSM(k)+A2_ASSSM(k)*H+A3_ASSSM(k)/(H-1.05)
-                tau(i,k,la,spsol) = mass_temp(i,k,spsol)*1000.*zdp1(i,k)   &
+                tau(i,k,la,aerindex) = mass_temp(i,k,aerindex)*1000.*zdp1(i,k)   &
                                    *tau_ae5wv_int*delt*fac
-                tausum(i,la,spsol)=tausum(i,la,spsol)+tau(i,k,la,spsol)
+                tausum(i,la,aerindex)=tausum(i,la,aerindex)+tau(i,k,la,aerindex)
               ENDDO
             ENDDO
@@ -794,7 +798,7 @@
                 H=rh(i,k)/100
                 tau_ae5wv_int=A1_CSSSM(k)+A2_CSSSM(k)*H+A3_CSSSM(k)/(H-1.05)
-                tau(i,k,la,spsol) = mass_temp(i,k,spsol)*1000.*zdp1(i,k)  &
+                tau(i,k,la,aerindex) = mass_temp(i,k,aerindex)*1000.*zdp1(i,k)  &
                                    *tau_ae5wv_int*delt*fac
-                tausum(i,la,spsol) = tausum(i,la,spsol)+tau(i,k,la,spsol)
+                tausum(i,la,aerindex) = tausum(i,la,aerindex)+tau(i,k,la,aerindex)
               ENDDO
             ENDDO
@@ -809,7 +813,7 @@
                 H=rh(i,k)/100
                 tau_ae5wv_int=A1_SSSSM(k)+A2_SSSSM(k)*H+A3_SSSSM(k)/(H-1.05)
-                tau(i,k,la,spsol) = mass_temp(i,k,spsol)*1000.*zdp1(i,k)  &
+                tau(i,k,la,aerindex) = mass_temp(i,k,aerindex)*1000.*zdp1(i,k)  &
                                    *tau_ae5wv_int*delt*fac
-                tausum(i,la,spsol)=tausum(i,la,spsol)+tau(i,k,la,spsol)
+                tausum(i,la,aerindex)=tausum(i,la,aerindex)+tau(i,k,la,aerindex)
               ENDDO
             ENDDO
@@ -824,7 +828,7 @@
                               alpha_aers_5wv(RH_num(i,k),la,spsol))
 
-              tau(i,k,la,spsol) = mass_temp(i,k,spsol)*1000.*zdp1(i,k)   &
+              tau(i,k,la,aerindex) = mass_temp(i,k,aerindex)*1000.*zdp1(i,k)   &
                                  *tau_ae5wv_int*delt*fac
-              tausum(i,la,spsol)=tausum(i,la,spsol)+tau(i,k,la,spsol)
+              tausum(i,la,aerindex)=tausum(i,la,aerindex)+tau(i,k,la,aerindex)
             ENDDO
           ENDDO
@@ -836,8 +840,7 @@
           DO i=1, KLON
             tau_ae5wv_int = alpha_aeri_5wv(la,spinsol)
-            tau(i,k,la,naero_soluble+spinsol) = mass_temp(i,k,naero_soluble+spinsol)*1000.*zdp1(i,k)* &
+            tau(i,k,la,aerindex) = mass_temp(i,k,aerindex)*1000.*zdp1(i,k)* &
                                                 tau_ae5wv_int*delt*fac
-            tausum(i,la,naero_soluble+spinsol)= tausum(i,la,naero_soluble+spinsol)  &
-                                               +tau(i,k,la,naero_soluble+spinsol)
+            tausum(i,la,aerindex)= tausum(i,la,aerindex)+tau(i,k,la,aerindex)
           ENDDO
         ENDDO
@@ -880,7 +883,7 @@
   END DO
   
-   od550lt1aer(:)=tausum(:,2,id_ASSO4M)+tausum(:,2,id_ASBCM)+tausum(:,2,id_AIBCM)+ &
-	tausum(:,2,id_ASPOMM)+tausum(:,2,id_AIPOMM)+tausum(:,2,id_ASSSM)+ &
-	0.03*tausum(:,2,id_CSSSM)+0.4*tausum(:,2,id_CIDUSTM)
+   od550lt1aer(:)=tausum(:,2,id_ASSO4M_phy)+tausum(:,2,id_ASBCM_phy)+tausum(:,2,id_AIBCM_phy)+ &
+	tausum(:,2,id_ASPOMM_phy)+tausum(:,2,id_AIPOMM_phy)+tausum(:,2,id_ASSSM_phy)+ &
+	0.03*tausum(:,2,id_CSSSM_phy)+0.4*tausum(:,2,id_CIDUSTM_phy)
 
 
Index: /LMDZ5/trunk/libf/phylmd/phys_local_var_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phys_local_var_mod.F90	(revision 2145)
+++ /LMDZ5/trunk/libf/phylmd/phys_local_var_mod.F90	(revision 2146)
@@ -96,4 +96,11 @@
       REAL, SAVE, ALLOCATABLE :: topswcf_aero(:,:),  solswcf_aero(:,:)  ! diag
       !$OMP THREADPRIVATE(topswcf_aero,solswcf_aero)
+! LW radiation diagnostics CK
+      REAL, SAVE, ALLOCATABLE :: toplwad_aero(:),  sollwad_aero(:)      ! diag
+      !$OMP THREADPRIVATE(toplwad_aero,sollwad_aero)
+      REAL, SAVE, ALLOCATABLE :: toplwai_aero(:),  sollwai_aero(:)      ! diag
+      !$OMP THREADPRIVATE(toplwai_aero,sollwai_aero)
+      REAL, SAVE, ALLOCATABLE :: toplwad0_aero(:), sollwad0_aero(:)     ! diag
+      !$OMP THREADPRIVATE(toplwad0_aero,sollwad0_aero)
 ! Special RRTM
       REAL, SAVE, ALLOCATABLE :: ZLWFT0_i(:,:),  ZSWFT0_i(:,:)      ! diag
@@ -140,4 +147,6 @@
       REAL, SAVE, ALLOCATABLE :: sconcso4(:) 
       !$OMP THREADPRIVATE(sconcso4) 
+      REAL, SAVE, ALLOCATABLE :: sconcno3(:) 
+      !$OMP THREADPRIVATE(sconcno3) 
       REAL, SAVE, ALLOCATABLE :: sconcoa(:) 
       !$OMP THREADPRIVATE(sconcoa) 
@@ -150,4 +159,6 @@
       REAL, SAVE, ALLOCATABLE :: concso4(:,:) 
       !$OMP THREADPRIVATE(concso4) 
+      REAL, SAVE, ALLOCATABLE :: concno3(:,:) 
+      !$OMP THREADPRIVATE(concno3) 
       REAL, SAVE, ALLOCATABLE :: concoa(:,:) 
       !$OMP THREADPRIVATE(concoa) 
@@ -197,4 +208,11 @@
 !$OMP THREADPRIVATE(topswcf_aerop, solswcf_aerop)
 
+! additional LW variables CK
+      REAL,ALLOCATABLE,SAVE :: toplwad_aerop(:), sollwad_aerop(:)
+!$OMP THREADPRIVATE(toplwad_aerop, sollwad_aerop)
+      REAL,ALLOCATABLE,SAVE :: toplwai_aerop(:), sollwai_aerop(:)
+!$OMP THREADPRIVATE(toplwai_aerop, sollwai_aerop)
+      REAL,ALLOCATABLE,SAVE :: toplwad0_aerop(:), sollwad0_aerop(:)
+!$OMP THREADPRIVATE(toplwad0_aerop, sollwad0_aerop)
 
 !Ajout de celles nécessaires au phys_output_write_mod
@@ -337,4 +355,9 @@
       allocate(topswai_aero(klon), solswai_aero(klon))
       allocate(topswad0_aero(klon), solswad0_aero(klon))
+     ! LW diagnostics CK
+      allocate(toplwad_aero(klon), sollwad_aero(klon))
+      allocate(toplwai_aero(klon), sollwai_aero(klon))
+      allocate(toplwad0_aero(klon), sollwad0_aero(klon))
+      ! end
       allocate(topsw_aero(klon,naero_grp), solsw_aero(klon,naero_grp))
       allocate(topsw0_aero(klon,naero_grp), solsw0_aero(klon,naero_grp))
@@ -363,4 +386,5 @@
       allocate(od550lt1aer(klon))	 	 
       allocate(sconcso4(klon))
+      allocate(sconcno3(klon))
       allocate(sconcoa(klon))
       allocate(sconcbc(klon))
@@ -368,4 +392,5 @@
       allocate(sconcdust(klon))
       allocate(concso4(klon,klev))
+      allocate(concno3(klon,klev))
       allocate(concoa(klon,klev))
       allocate(concbc(klon,klev))
@@ -392,4 +417,9 @@
       ALLOCATE(solsw_aerop(klon,naero_grp), solsw0_aerop(klon,naero_grp))
       ALLOCATE(topswcf_aerop(klon,naero_grp), solswcf_aerop(klon,naero_grp))
+
+! additional LW variables CK
+      ALLOCATE(toplwad_aerop(klon), sollwad_aerop(klon))
+      ALLOCATE(toplwai_aerop(klon), sollwai_aerop(klon))
+      ALLOCATE(toplwad0_aerop(klon), sollwad0_aerop(klon))
 
 ! FH Ajout de celles nécessaires au phys_output_write_mod
@@ -496,4 +526,9 @@
       deallocate(topswai_aero,solswai_aero)
       deallocate(topswad0_aero,solswad0_aero)
+      ! LW additional CK
+      deallocate(toplwad_aero,sollwad_aero)
+      deallocate(toplwai_aero,sollwai_aero)
+      deallocate(toplwad0_aero,sollwad0_aero)
+      ! end
       deallocate(topsw_aero,solsw_aero)
       deallocate(topsw0_aero,solsw0_aero)
@@ -517,4 +552,5 @@
       deallocate(od550lt1aer)
       deallocate(sconcso4) 
+      deallocate(sconcno3) 
       deallocate(sconcoa) 
       deallocate(sconcbc) 
@@ -522,4 +558,5 @@
       deallocate(sconcdust) 
       deallocate(concso4) 
+      deallocate(concno3) 
       deallocate(concoa) 
       deallocate(concbc) 
@@ -549,4 +586,8 @@
       deallocate(topswcf_aerop, solswcf_aerop)
 
+!CK LW diagnostics
+      deallocate(toplwad_aerop, sollwad_aerop)
+      deallocate(toplwai_aerop, sollwai_aerop)
+      deallocate(toplwad0_aerop, sollwad0_aerop)
 
 ! FH Ajout de celles nécessaires au phys_output_write_mod
Index: /LMDZ5/trunk/libf/phylmd/phys_output_ctrlout_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 2145)
+++ /LMDZ5/trunk/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 2146)
@@ -3,5 +3,5 @@
   USE phys_output_var_mod
   USE indice_sol_mod
-  USE aero_mod, only : naero_tot,name_aero_tau
+  USE aero_mod
 
 
@@ -736,28 +736,51 @@
   TYPE(ctrl_out), SAVE :: o_solswai = ctrl_out((/ 2, 10, 10, 10, 10, 10, 11, 11, 11 /), &
     'solswai', 'AIE at SFR', 'W/m2', (/ ('', i=1, 9) /))
-
-  type(ctrl_out),save,dimension(naero_tot) :: o_tausumaero  =                           & 
-    (/ ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_ASBCM',                        &
-      "Aerosol Optical depth at 550 nm "//name_aero_tau(1),"1", (/ ('', i=1, 9) /)), &
-       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_ASPOMM',                       &
-      "Aerosol Optical depth at 550 nm "//name_aero_tau(2),"1", (/ ('', i=1, 9) /)), &
-       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_ASSO4M',                       &
-      "Aerosol Optical depth at 550 nm "//name_aero_tau(3),"1", (/ ('', i=1, 9) /)), &
-       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_CSSO4M',                       &
-      "Aerosol Optical depth at 550 nm "//name_aero_tau(4),"1", (/ ('', i=1, 9) /)), &
-       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_SSSSM',                        &
-      "Aerosol Optical depth at 550 nm "//name_aero_tau(5),"1", (/ ('', i=1, 9) /)), &
-       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_ASSSM',                        &
-      "Aerosol Optical depth at 550 nm "//name_aero_tau(6),"1", (/ ('', i=1, 9) /)), &
-       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_CSSSM',                        &
-      "Aerosol Optical depth at 550 nm "//name_aero_tau(7),"1", (/ ('', i=1, 9) /)), &
-       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_CIDUSTM',                      &
-      "Aerosol Optical depth at 550 nm "//name_aero_tau(8),"1", (/ ('', i=1, 9) /)), &
-       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_AIBCM',                        &
-      "Aerosol Optical depth at 550 nm "//name_aero_tau(9),"1", (/ ('', i=1, 9) /)), &
-       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_AIPOMM',                       &
-      "Aerosol Optical depth at 550 nm "//name_aero_tau(10),"1", (/ ('', i=1, 9) /)),&
-       ctrl_out((/ 2, 2, 10, 10, 10, 10, 11, 11, 11 /),'OD550_STRAT',                        &
-      "Aerosol Optical depth at 550 nm "//name_aero_tau(11),"1", (/ ('', i=1, 9) /)) /)
+  TYPE(ctrl_out), SAVE :: o_toplwad = ctrl_out((/ 2, 10, 10, 10, 10, 10, 11, 11, 11 /), &
+    'toplwad', 'LW-ADE at TOA', 'W/m2', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_toplwad0 = ctrl_out((/ 2, 10, 10, 10, 10, 10, 11, 11, 11 /), &
+    'toplwad0', 'LW-ADE clear-sky at TOA', 'W/m2', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_toplwai = ctrl_out((/ 2, 10, 10, 10, 10, 10, 11, 11, 11 /), &
+    'toplwai', 'LW-AIE at TOA', 'W/m2', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_sollwad = ctrl_out((/ 2, 10, 10, 10, 10, 10, 11, 11, 11 /), &
+    'sollwad', 'LW-ADE at SRF', 'W/m2', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_sollwad0 = ctrl_out((/ 2, 10, 10, 10, 10, 10, 11, 11, 11 /), &
+    'sollwad0', 'LW-ADE clear-sky at SRF', 'W/m2', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_sollwai = ctrl_out((/ 2, 10, 10, 10, 10, 10, 11, 11, 11 /), &
+    'sollwai', 'LW-AIE at SFR', 'W/m2', (/ ('', i=1, 9) /))
+
+  type(ctrl_out),save,dimension(naero_tot) :: o_tausumaero =                           &
+    (/ ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_'//name_aero_tau(1),      &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(1),"1", (/ ('', i=1, 9) /)),    &
+       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_'//name_aero_tau(2),      &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(2),"2", (/ ('', i=1, 9) /)),    &
+       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_'//name_aero_tau(3),      &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(2),"3", (/ ('', i=1, 9) /)),    &
+       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_'//name_aero_tau(4),      &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(2),"4", (/ ('', i=1, 9) /)),    &
+       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_'//name_aero_tau(5),      &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(2),"5", (/ ('', i=1, 9) /)),    &
+       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_'//name_aero_tau(6),      &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(2),"6", (/ ('', i=1, 9) /)),    &
+       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_'//name_aero_tau(7),      &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(2),"7", (/ ('', i=1, 9) /)),    &
+       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_'//name_aero_tau(8),      &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(2),"8", (/ ('', i=1, 9) /)),    &
+       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_'//name_aero_tau(9),      &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(2),"9", (/ ('', i=1, 9) /)),    &
+       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_'//name_aero_tau(10),     &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(2),"10", (/ ('', i=1, 9) /)),   &
+       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_'//name_aero_tau(11),     &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(2),"11", (/ ('', i=1, 9) /)),   &
+       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_'//name_aero_tau(12),     &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(2),"12", (/ ('', i=1, 9) /)),   &
+       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_'//name_aero_tau(13),     &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(2),"13", (/ ('', i=1, 9) /)),   &
+       ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_'//name_aero_tau(14),     &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(2),"14", (/ ('', i=1, 9) /))   /)
+
+
+!
+  TYPE(ctrl_out), SAVE :: o_tausumaero_lw = ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /), &
+    'OD_10um_STRAT', 'Stratospheric Aerosol Optical depth at 10 um ', '1', (/ ('', i=1, 9) /))
 !
   TYPE(ctrl_out), SAVE :: o_od550aer = ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /), &
@@ -771,4 +794,6 @@
   TYPE(ctrl_out), SAVE :: o_sconcso4 = ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /), &
     'sconcso4', 'Surface Concentration of Sulfate ', 'kg/m3', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_sconcno3 = ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /), &
+    'sconcno3', 'Surface Concentration of Nitrate ', 'kg/m3', (/ ('', i=1, 9) /))
   TYPE(ctrl_out), SAVE :: o_sconcoa = ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /), &
     'sconcoa', 'Surface Concentration of Organic Aerosol ', 'kg/m3', (/ ('', i=1, 9) /))
@@ -781,4 +806,6 @@
   TYPE(ctrl_out), SAVE :: o_concso4 = ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /), &
     'concso4', 'Concentration of Sulfate ', 'kg/m3', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_concno3 = ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /), &
+    'concno3', 'Concentration of Nitrate ', 'kg/m3', (/ ('', i=1, 9) /))
   TYPE(ctrl_out), SAVE :: o_concoa = ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /), &
     'concoa', 'Concentration of Organic Aerosol ', 'kg/m3', (/ ('', i=1, 9) /))
Index: /LMDZ5/trunk/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 2145)
+++ /LMDZ5/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 2146)
@@ -89,10 +89,11 @@
          o_dtsvdfg, o_dtsvdfi, o_rugs, o_od550aer, &
          o_od865aer, o_absvisaer, o_od550lt1aer, &
-         o_sconcso4, o_sconcoa, o_sconcbc, &
-         o_sconcss, o_sconcdust, o_concso4, &
+         o_sconcso4, o_sconcno3, o_sconcoa, o_sconcbc, &
+         o_sconcss, o_sconcdust, o_concso4, o_concno3, &
          o_concoa, o_concbc, o_concss, o_concdust, &
          o_loadso4, o_loadoa, o_loadbc, o_loadss, &
-         o_loaddust, o_tausumaero, o_topswad, &
-         o_topswad0, o_solswad, o_solswad0, &
+         o_loaddust, o_tausumaero, o_tausumaero_lw, &
+         o_topswad, o_topswad0, o_solswad, o_solswad0, &
+         o_toplwad, o_toplwad0, o_sollwad, o_sollwad0, &
          o_swtoaas_nat, o_swsrfas_nat, &
          o_swtoacs_nat, o_swtoaas_ant, &
@@ -195,6 +196,6 @@
          pmflxr, pmflxs, prfl, psfl, re, fl, rh2m, &
          qsat2m, tpote, tpot, d_ts, zxrugs, od550aer, &
-         od865aer, absvisaer, od550lt1aer, sconcso4, &
-         sconcoa, sconcbc, sconcss, sconcdust, concso4, &
+         od865aer, absvisaer, od550lt1aer, sconcso4, sconcno3, &
+         sconcoa, sconcbc, sconcss, sconcdust, concso4, concno3, &
          concoa, concbc, concss, concdust, loadso4, &
          loadoa, loadbc, loadss, loaddust, tausum_aero, &
@@ -203,4 +204,6 @@
          topsw0_aero, solsw0_aero, topswcf_aero, &
          solswcf_aero, topswai_aero, solswai_aero, &
+         toplwad_aero, toplwad0_aero, sollwad_aero, &
+         sollwad0_aero, toplwai_aero, sollwai_aero, &
          scdnc, cldncl, reffclws, reffclwc, cldnvi, &
          lcc, lcc3d, lcc3dcon, lcc3dstra, reffclwtop, &
@@ -228,5 +231,5 @@
     USE surface_data, only: type_ocean, ok_veget, ok_snow
 !    USE aero_mod, only: naero_spc
-    USE aero_mod, only: naero_tot
+    USE aero_mod, only: naero_tot, id_STRAT_phy
     USE ioipsl, only: histend, histsync
     USE iophy, only: set_itau_iophy, histwrite_phy
@@ -331,8 +334,6 @@
        CALL histwrite_phy(o_t2m_min, zt2m)
        CALL histwrite_phy(o_t2m_max, zt2m)
-       if (.not. ok_all_xml) then
-         CALL histwrite_phy(o_t2m_max_mon, t2m_max_mon)
-         CALL histwrite_phy(o_t2m_min_mon, t2m_min_mon)
-       endif
+       CALL histwrite_phy(o_t2m_max_mon, t2m_max_mon)
+       CALL histwrite_phy(o_t2m_min_mon, t2m_min_mon)
 
        IF (vars_defined) THEN
@@ -795,5 +796,8 @@
        CALL histwrite_phy(o_rugs, zxrugs)
        ! OD550 per species
-       IF (new_aod .and. (.not. aerosol_couple)) THEN
+!--OLIVIER
+!This is warranted by treating INCA aerosols as offline aerosols
+!       IF (new_aod .and. (.not. aerosol_couple)) THEN
+       IF (new_aod) THEN
           IF (flag_aerosol.GT.0) THEN
              CALL histwrite_phy(o_od550aer, od550aer)
@@ -802,4 +806,5 @@
              CALL histwrite_phy(o_od550lt1aer, od550lt1aer)
              CALL histwrite_phy(o_sconcso4, sconcso4)
+             CALL histwrite_phy(o_sconcno3, sconcno3)
              CALL histwrite_phy(o_sconcoa, sconcoa)
              CALL histwrite_phy(o_sconcbc, sconcbc)
@@ -807,4 +812,5 @@
              CALL histwrite_phy(o_sconcdust, sconcdust)
              CALL histwrite_phy(o_concso4, concso4)
+             CALL histwrite_phy(o_concno3, concno3)
              CALL histwrite_phy(o_concoa, concoa)
              CALL histwrite_phy(o_concbc, concbc)
@@ -826,4 +832,8 @@
              END DO
           ENDIF
+          IF (flag_aerosol_strat) THEN
+             CALL histwrite_phy(o_tausumaero_lw, &
+                  tausum_aero(:,6,id_STRAT_phy) )
+          ENDIF
        ENDIF
        IF (ok_ade) THEN
@@ -832,4 +842,8 @@
           CALL histwrite_phy(o_solswad, solswad_aero)
           CALL histwrite_phy(o_solswad0, solswad0_aero)
+          CALL histwrite_phy(o_toplwad, toplwad_aero)
+          CALL histwrite_phy(o_toplwad0, toplwad0_aero)
+          CALL histwrite_phy(o_sollwad, sollwad_aero)
+          CALL histwrite_phy(o_sollwad0, sollwad0_aero)
           !====MS forcing diagnostics
           if (new_aod) then
Index: /LMDZ5/trunk/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phys_state_var_mod.F90	(revision 2145)
+++ /LMDZ5/trunk/libf/phylmd/phys_state_var_mod.F90	(revision 2146)
@@ -349,6 +349,8 @@
       REAL,SAVE,ALLOCATABLE :: tau_aero(:,:,:,:), piz_aero(:,:,:,:), cg_aero(:,:,:,:)
 !$OMP THREADPRIVATE(tau_aero, piz_aero, cg_aero)
-      REAL,SAVE,ALLOCATABLE :: tau_aero_rrtm(:,:,:,:), piz_aero_rrtm(:,:,:,:), cg_aero_rrtm(:,:,:,:)
-!$OMP THREADPRIVATE(tau_aero_rrtm, piz_aero_rrtm, cg_aero_rrtm)
+      REAL,SAVE,ALLOCATABLE :: tau_aero_sw_rrtm(:,:,:,:), piz_aero_sw_rrtm(:,:,:,:), cg_aero_sw_rrtm(:,:,:,:)
+!$OMP THREADPRIVATE(tau_aero_sw_rrtm, piz_aero_sw_rrtm, cg_aero_sw_rrtm)
+      REAL,SAVE,ALLOCATABLE :: tau_aero_lw_rrtm(:,:,:,:), piz_aero_lw_rrtm(:,:,:,:), cg_aero_lw_rrtm(:,:,:,:)
+!$OMP THREADPRIVATE(tau_aero_lw_rrtm, piz_aero_lw_rrtm, cg_aero_lw_rrtm)
       REAL,SAVE,ALLOCATABLE :: ccm(:,:,:)
 !$OMP THREADPRIVATE(ccm)
@@ -519,6 +521,8 @@
       ALLOCATE(topswai(klon), solswai(klon))
       ALLOCATE(tau_aero(klon,klev,naero_grp,nbands),piz_aero(klon,klev,naero_grp,nbands),cg_aero(klon,klev,naero_grp,nbands))
-      ALLOCATE(tau_aero_rrtm(klon,klev,2,nbands_rrtm),piz_aero_rrtm(klon,klev,2,nbands_rrtm))
-      ALLOCATE(cg_aero_rrtm(klon,klev,2,nbands_rrtm))
+      ALLOCATE(tau_aero_sw_rrtm(klon,klev,2,nbands_sw_rrtm),piz_aero_sw_rrtm(klon,klev,2,nbands_sw_rrtm))
+      ALLOCATE(cg_aero_sw_rrtm(klon,klev,2,nbands_sw_rrtm))
+      ALLOCATE(tau_aero_lw_rrtm(klon,klev,2,nbands_lw_rrtm),piz_aero_lw_rrtm(klon,klev,2,nbands_lw_rrtm))
+      ALLOCATE(cg_aero_lw_rrtm(klon,klev,2,nbands_lw_rrtm))
       ALLOCATE(ccm(klon,klev,nbands))
 
@@ -635,5 +639,6 @@
       deallocate(topswai, solswai)
       deallocate(tau_aero,piz_aero,cg_aero)
-      deallocate(tau_aero_rrtm,piz_aero_rrtm,cg_aero_rrtm)
+      deallocate(tau_aero_sw_rrtm,piz_aero_sw_rrtm,cg_aero_sw_rrtm)
+      deallocate(tau_aero_lw_rrtm,piz_aero_lw_rrtm,cg_aero_lw_rrtm)
       deallocate(ccm)
       if (ok_gwd_rando) deallocate(du_gwd_rando, dv_gwd_rando)
Index: /LMDZ5/trunk/libf/phylmd/physiq.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/physiq.F90	(revision 2145)
+++ /LMDZ5/trunk/libf/phylmd/physiq.F90	(revision 2146)
@@ -2761,6 +2761,6 @@
      !jq - Johannes Quaas, 27/11/2003 (quaas@lmd.jussieu.fr)
      IF (flag_aerosol .gt. 0) THEN
-        IF (.NOT. aerosol_couple) THEN
-           IF (iflag_rrtm .EQ. 0) THEN !--old radiation
+        IF (iflag_rrtm .EQ. 0) THEN !--old radiation
+           IF (.NOT. aerosol_couple) THEN
               !
               CALL readaerosol_optic( &
@@ -2770,18 +2770,21 @@
                    tau_aero, piz_aero, cg_aero,  &
                    tausum_aero, tau3d_aero)
-              !
-           ELSE                       ! RRTM radiation
-              !
+           ENDIF
+         ELSE                       ! RRTM radiation
+           IF (aerosol_couple .AND. config_inca == 'aero' ) THEN
+            abort_message='config_inca=aero et rrtm=1 impossible'
+            call abort_gcm(modname,abort_message,1)
+           ELSE
+!
 #ifdef CPP_RRTM
-              CALL readaerosol_optic_rrtm( &
-                   debut, new_aod, flag_aerosol, itap, jD_cur-jD_ref, &
-                   pdtphys, pplay, paprs, t_seri, rhcl, presnivs,  &
-                   mass_solu_aero, mass_solu_aero_pi,  &
-                   tau_aero_rrtm, piz_aero_rrtm, cg_aero_rrtm,  &
-                   tausum_aero, tau3d_aero)
+             CALL readaerosol_optic_rrtm( debut, aerosol_couple, &
+             new_aod, flag_aerosol, itap, jD_cur-jD_ref, &
+             pdtphys, pplay, paprs, t_seri, rhcl, presnivs,  &
+             tr_seri, mass_solu_aero, mass_solu_aero_pi,  &
+             tau_aero_sw_rrtm, piz_aero_sw_rrtm, cg_aero_sw_rrtm,  &
+             tausum_aero, tau3d_aero)
 #else
 
-              abort_message = 'You should compile with -rrtm if running ' &
-                   // 'with iflag_rrtm=1'
+              abort_message='You should compile with -rrtm if running with iflag_rrtm=1'
               call abort_gcm(modname,abort_message,1)
 #endif
@@ -2796,7 +2799,7 @@
            cg_aero(:,:,:,:)  = 0.
         ELSE
-           tau_aero_rrtm(:,:,:,:)=0.0
-           piz_aero_rrtm(:,:,:,:)=0.0
-           cg_aero_rrtm(:,:,:,:)=0.0
+           tau_aero_sw_rrtm(:,:,:,:)=0.0
+           piz_aero_sw_rrtm(:,:,:,:)=0.0
+           cg_aero_sw_rrtm(:,:,:,:)=0.0
         ENDIF
      ENDIF
@@ -2980,5 +2983,5 @@
 
      call chemtime(itap+itau_phy-1, date0, dtime)
-     IF (config_inca == 'aero') THEN
+     IF (config_inca == 'aero' .OR. config_inca == 'aeNP') THEN
         CALL AEROSOL_METEO_CALC( &
              calday,pdtphys,pplay,paprs,t,pmflxr,pmflxs, &
@@ -3192,5 +3195,6 @@
              flag_aerosol_strat, &
              tau_aero, piz_aero, cg_aero, &
-             tau_aero_rrtm, piz_aero_rrtm, cg_aero_rrtm,&     ! Rajoute par OB pour RRTM
+             tau_aero_sw_rrtm, piz_aero_sw_rrtm, cg_aero_sw_rrtm,&     ! Rajoute par OB pour RRTM
+             tau_aero_lw_rrtm, & 
              cldtaupirad,new_aod, &
              zqsat, flwc, fiwc, &
@@ -3208,4 +3212,9 @@
              solsw_aero, solsw0_aero, &
              topswcf_aero, solswcf_aero, &
+             !-C. Kleinschmitt for LW diagnostics
+             toplwad_aero, sollwad_aero,&
+             toplwai_aero, sollwai_aero, &
+             toplwad0_aero, sollwad0_aero,&
+             !-end
              ZLWFT0_i, ZFLDN0, ZFLUP0, &
              ZSWFT0_i, ZFSDN0, ZFSUP0)
@@ -3239,5 +3248,6 @@
                    flag_aerosol_strat, &
                    tau_aero, piz_aero, cg_aero, &
-                   tau_aero_rrtm, piz_aero_rrtm, cg_aero_rrtm,&     ! Rajoute par OB pour RRTM
+                   tau_aero_sw_rrtm, piz_aero_sw_rrtm, cg_aero_sw_rrtm,&     ! Rajoute par OB pour RRTM
+                   tau_aero_lw_rrtm, &
                    cldtaupi,new_aod, &
                    zqsat, flwc, fiwc, &
@@ -3255,4 +3265,9 @@
                    solsw_aerop, solsw0_aerop, &
                    topswcf_aerop, solswcf_aerop, &
+                   !-C. Kleinschmitt for LW diagnostics
+                   toplwad_aerop, sollwad_aerop,&
+                   toplwai_aerop, sollwai_aerop, &
+                   toplwad0_aerop, sollwad0_aerop,&
+                   !-end
                    ZLWFT0_i, ZFLDN0, ZFLUP0, &
                    ZSWFT0_i, ZFSDN0, ZFSUP0)
